# Code for the City class
#
# Copyright 1996-97 Chris Lawrence
# This file may be freely distributed under the terms of the RoutePlanner
# license.  A copy should appear as 'LICENSE' in the archive that this
# file was included in.

import string

invalidformat = 'rpcity.invalidformat'

class City:
    def __init__(self, data=None):
        if data:
            pos = string.rfind(data[0], ', ')
            if pos == -1:
                raise invalidformat, 'No commas found in city name '+data[0]
            self.city = data[0][:pos]
            self.state = data[0][pos+2:]
            if data[1] == 'I':
                self.intersection = 1
            else:
                self.intersection = 0
            self.longitude = float(data[2])
            self.latitude = float(data[3])
            self.__printable = self.city + ', ' + self.state
        else:
            self.city = self.state = None
            self.longitude = self.latitude = 0.0
            self.intersection = 0
            self.__printable = '(Null)'
        
        self.roads = []

    def __repr__(self):
        if self.intersection:
            return '%s, %s|I|%f|%f' % (self.city, self.state, self.latitude,
                                       self.longitude)
        else:
            return '%s, %s||%f|%f' % (self.city, self.state, self.latitude,
                                       self.longitude)
    def __str__(self):
        return self.__printable


    def __cmp__(self, other):
        return cmp(hash(self), hash(other))
    
    def __hash__(self):
        return id(self)
# End of City
