# Code for the Route class
#
# Copyright 1996-97 Chris Lawrence
# This file may be freely distributed under the terms of the RoutePlanner
# license.  A copy should appear as 'LICENSE' in the archive that this
# file was included in.

import string

class Route:
    def __init__(self, data=None, cities=None):
        if data and cities:
            citynames = data[0:2]
            self.exits = data[5:7]
            # Lower city name comes first; this will help provide a
            # uniform file format for patching
            if string.lower(citynames[0]) > string.lower(citynames[1]):
                citynames.reverse()
                self.exits.reverse()
            
            stuff = string.split(data[2])
            self.distance = int(stuff[0])
            self.units = stuff[1]
            self.speed = int(data[3])
            self.speedcode = int(data[4])
            self.name = data[7]
            
            self.city = [ cities[citynames[0]][0], cities[citynames[1]][0] ]
            self.city[0].roads.append( (self, 0, self.city[1]) )
            self.city[1].roads.append( (self, 1, self.city[0]) )
        else:
            self.city = [None]*2
            self.exits = [None]*2
            self.distance = self.speed = self.speedcode = \
                            self.name = self.units = None

    def __repr__(self):
        return str(self.city[0])+'|'+str(self.city[1])+'|'+\
               str(self.distance)+' '+str(self.units)+'|'+str(self.speed)+'|'+\
               str(self.speedcode)+'|'+self.exits[0]+'|'+self.exits[1]+'|'+\
               self.name

    def __str__(self):
        return self.name

    def __cmp__(self, other):
        return cmp(hash(self), hash(other))
    
    def __hash__(self):
        return id(self)
# End of Route
